import React, { useContext, useEffect, useState } from 'react';
import { CommonMenuList, Headline } from "../component/mod";
import { UserContext } from "../state";
import { Grid, Paper, Typography } from "@material-ui/core";

export function DifferencePage(){
    const ctx = useContext(UserContext);
    const [diffList,setDiffList] = useState<
        {type:string,value:{path:string,type:string}[]}[]
    >([]);
    const doLoad = async ()=>{
        const list = await fetch('/api/diff/list');
        if(list.ok){
           const inner = await list.json();
           setDiffList(inner);
        }
        else{
            //setDiffList([]);
        }
    };
    useEffect(
        ()=>{
            doLoad();
            const i = setInterval(doLoad,5000);
            return ()=>{
                clearInterval(i);
            }
        },[]
    )
    const Commit = async(x:{type:string,path:string})=>{
        const res = await fetch('/api/diff/commit',{
            method:'POST',
            body: JSON.stringify([{...x}]),
            headers:{
                'content-type':'application/json'
            }
        });
        const bb = await res.json();
        if(bb.ok){
            doLoad();
        }
    } 
    const menu = CommonMenuList();

    return (<Headline menu={menu}>
        {diffList.map(x=><Paper key={x.type}>
            <Typography variant='h3'>{x.type}</Typography>
            {x.value.map(y=><Typography variant='h5' onClick={()=>Commit(y)}>{y.path}</Typography>)}
        </Paper>)}
    </Headline>)
}