import { DocumentAccessor } from '../model/doc';
import {ContentDiffHandler} from './content_handler';
import { CommonDiffWatcher } from './watcher';
//import {join as pathjoin} from 'path';
export class DiffManager{
    watching: {[content_type:string]:ContentDiffHandler};
    doc_cntr: DocumentAccessor;
    constructor(contorller: DocumentAccessor){
        this.watching = {};
        this.doc_cntr = contorller;
    }
    async register(content_type:string,path:string){
        if(this.watching[content_type] === undefined){
            this.watching[content_type] = new ContentDiffHandler(this.doc_cntr,content_type);
        }
        const watcher = new CommonDiffWatcher(path);
        this.watching[content_type].register(watcher);
        const initial_doc = await this.doc_cntr.findByPath(path);
        await watcher.setup(initial_doc.map(x=>x.filename));
        watcher.watch();
    }
    async commit(type:string,path:string){
        const list = this.watching[type].waiting_list;
        const c = list.getPath(path);
        if(c===undefined){
            throw new Error("path is not exist");
        }
        await list.delete(c);
        const body = await c.createDocumentBody();
        const id = await this.doc_cntr.add(body);
        return id;
    }
    getAdded(){
        return Object.keys(this.watching).map(x=>({
            type:x,
            value:this.watching[x].waiting_list.getAll(),
        }));
    }
};