import Knex from "knex";

declare module "knex" {
  interface Tables {
    tags: {
      name: string;
      description?: string;
    };
    users: {
      username: string;
      password_hash: string;
      password_salt: string;
    };
    document: {
      id: number;
      title: string;
      content_type: string;
      basepath: string;
      filename: string;
      created_at: number;
      deleted_at: number|null;
      content_hash: string;
      additional: string|null;
    };
    doc_tag_relation: {
      doc_id: number;
      tag_name: string;
    };
    permissions: {
      username: string;
      name: string;
    };
  }
  namespace Knex {
  }
}
